/** ZCT/book.h--Created 091507 **/
#include "zct.h"
#include "pgn.h"

#ifndef BOOK_H
#define BOOK_H

/* The data structure for a book position. The hashkey is a mixture of the current position
	and the position after the book move. */
typedef struct
{
	HASHKEY hashkey;
	short wins;
	short losses;
	short draws;
	char flags;
	char learn;
} BOOK_POSITION;

typedef struct
{
	BOOK_POSITION *book_buffer;
	int buffer_size;
	int depth;
} BOOK_PGN_INFO;

#define BOOK_UPPER_MASK			(0xFFFF000000000000ull)
#define BOOK_LOWER_MASK			(0x0000FFFFFFFFFFFFull)

extern FILE *book_file;

BOOK_POSITION *bytes_to_book(unsigned char *bytes);
unsigned char *book_to_bytes(BOOK_POSITION *book_position);
BOOL book_pgn_func(void *pgn_arg, PGN_GAME *pgn_game);

#endif /* BOOK_H */
