/** ZCT/debug.h--Created 102206 **/
#include "zct.h"

#ifndef DEBUG_H
#define DEBUG_H

#ifdef DEBUG_SEARCH

typedef enum { DEBUG_ALWAYS, DEBUG_HASHKEY, DEBUG_PLY, DEBUG_MOVE, DEBUG_SCORE_GT, DEBUG_SCORE_LT } DEBUG_COND_TYPE;
typedef enum { DEBUG_COND_OR, DEBUG_COND_AND } DEBUG_COND_MODE;

typedef struct DEBUG_COND
{
	BOOL active;
	DEBUG_COND_TYPE cond_type;
	BITBOARD data;
} DEBUG_COND;

#define COND_STACK_SIZE			(32)

extern DEBUG_COND cond_stack[COND_STACK_SIZE];
extern int cond_count;
extern DEBUG_COND_MODE cond_mode;
extern BOOL debug_break;

/* Functions */
void debug(SEARCH_BLOCK *search_block);
void debug_set(DEBUG_COND_TYPE cond_type, BITBOARD data);
void debug_clear(int cond);
void debug_clear_all(void);
void debug_cond_print(void);
void debug_print(SEARCH_BLOCK *search_block);

#endif /* DEBUG_SEARCH */

#endif /* DEBUG_H */
