/** ZCT/pgn.h--Created 091407 **/
#include "zct.h"

#ifndef	PGN_H
#define PGN_H

typedef struct
{
	long offset;
	int move_count;
	struct
	{
		char event[128];
		char site[128];
		char date[128];
		char round[128];
		char white[128];
		char black[128];
		char result[128];
		char fen[128];
	} tag;
} PGN_GAME;

typedef struct
{
	int game_count;
	PGN_GAME *game;
} PGN_DATABASE;

typedef enum { NEUTRAL, HEADERS, MOVES } PGN_STATE;

typedef BOOL (*PGN_FUNC)(void *pgn_arg, PGN_GAME *pgn_game);

void pgn_load(int game_number, PGN_FUNC pgn_func, void *pgn_arg);

extern FILE *pgn_file;
extern PGN_GAME pgn_game;
extern PGN_DATABASE pgn_database;

#endif /* PGN_H */
